/*
 * SOMTreeClassifierTest.java
 * JUnit based test
 *
 * Created on 2007-09-09, 15:13
 */

package iaik.som;

import junit.framework.*;

/**
 * JUnit based test for SOMTreeClassifier.
 *
 * @author Gernot WALZL
 */
public class SOMTreeClassifierTest extends TestCase {

    public SOMTreeClassifierTest(String testName) {
        super(testName);
    }

    public void testClassify() {
        System.out.println("classify");

        double[][] trainingData = {{0.7036, 0.1400},
                {0.4850, 0.5668},
                {0.1146, 0.8230},
                {0.6649, 0.6739},
                {0.3654, 0.9994}};
        int[] classes = {0, 1, 1, 0, 1};

        SOMTreeClassifier classifier = new SOMTreeClassifier(
                trainingData, classes);

        double[][] testData = trainingData;
        int[] expected = {0, 1, 1, 0, 1};
        int[] result = classifier.classify(testData);

        assertTrue(MyMath.equalVector(expected, result));
    }

}
